Attribute VB_Name = "modChangeLog"
Option Explicit

'*********************************************************************************
'*                                  CHANGE LOG                                   *
'*********************************************************************************
'Release   Date      Change Description
'-------   --------  -------------------------------------------------------------
'01.00     07/07/08  o Publish on VB Forums
'01.10     07/12/08  o Added right-click popup menu
'                    o Correct small bug where direction button had to be pressed
'                      twice after ending slideshow
'                    o Added progress bar when loading pictures
'                    o Added option to set the number of photos that will trigger
'                      the display of the progress bar while loading the pictures.
'                    o Modified thumbnail display processing so that the thumbnail
'                      always displays the whole picture
'                    o Changes to accommodate 1024 x 768 resolution including form
'                      StartUpPosition (was CenterScreen)
'                    o Small correction for Apple cameras (Don't show "AppleMark" comment
'                    o Small change to the "Select the parent folder..." dialog
'                    o Replaced vbuSplitter2
'                    o Added code to save form position
'                    o Added more tips
'01.20     07/15/08  (a) Several changes to zoom function including:
'                        - Prevent zoomed image from becoming too large, or smaller than
'                          original size
'                        - Ctrl_r = re-center
'                        - Magnifying glass cursor
'                    (b) Found a second camera manufacturers comment ("U-Lead Systems, Inc."),
'                        so created frmComment dialog, gcolExclude (comments to be excluded),
'                        and mnuComments
'                    (c) Corrected problems when app closed in "Full Screen" mode
'                    (d) Reduced resize flutter problem by changing AutoRedraw property
'                        to True (Thanks to Half Flung Pie)
'                    (e) Correction and improvement to slideshow comments.
'                    (f) Use isZooming property instead of state of cmdZoom button
'                    (g) Smooth out "Picture"/"Pic" transition
'                    (h) Minimize picLeftPane when in slideshow
'01.30     07/25/08  (a) Added crop function
'                    (b) Added tooltips to frmDisplay
'                    (c) Corrected a problem where the same starting tooltip was always shown
'                        depending on how they were handled
'01.40     08/03/08  (a) Corrected major problem. Dicovered that PlanetSourceCode code WOULD
'                        damage the jpeg if the description is long. Replaced with FreeImage
'                        dll calls. Tested with 3000 character comment.
'                    (b) Corrected small bug where in rare circumstances a division by zero
'                        error could occur when creating a crop rectangle
'                    (c) Added error handler in timer code to handle bad picture there
'                    (d) Corrected small problem where the display of long comments was
'                        being cut off
'                    (e) Corrected small bug where in a long node list if the selected
'                        node required scrolling to get to then the selected node would go
'                        out of view after a slideshow
'                    (f) Corrected small bug where treeview width was not restored after
'                        running slideshow from Expanded view
'                    (g) Corrected small bug where when entering slideshow from full screen,
'                        current photo isn't resized
'                    (h) Added Horizontal scrollbar for use with thumbnails, Changed the
'                        thumbnail exiting method to Esc to be consistent
'                    (i) Load cursors and variable icons from resource file
'                    (j) Added pause/resume feature in slideshow
'                    (k) Changed next picture number processing for timer slightly so as
'                        to avoid problems when ending or pausing slideshow
'                    (l) Implemented a much faster method of finding the pictures in a folder
'                    (m) Start with optSize(0) and optSize(1) enabled
'                    (n) Make cmdDirecion invisible (like other buttons) instead of disabled
'                    (o) Changes so that picRightPane picture would not appear behind thumbnails
'                    (p) Removed optSize in favor of ControlBox
'                    (q) Rearranged command buttons and progressbar
'                    (r) Added more right-click popup menu items
'                    (misc) Miscellaneous changes
'01.50     08/18/08  (a) Added the ability to view movies
'                    (b) Use placeholder images instead of "invalid picture" messages and in
'                        situations like the slideshow where a movie can't be shown.
'                    (c) Handled user pressing Esc while thumbnails are being created
'                    (d) Corrected bug where hsb would appear when reducing screen size
'                    (e) Improvements to ResizeControls
'                    (f) Added code so that the name of the file always shows up in the form's caption
'                    (g) Corrected tab order of forms
'01.60     09/24/08  (a) Removed TipOfDay.txt and replaced with resource strings
'                    (b) Add picture names to thumbnails
'                    (c) Corrected bug involved in changing parent folder
'                    (misc) Miscellaneous changes
'01.70     02/22/10  (a) Corrected bug where previously if someone escaped out of a slideshow
'                        and then tried to do thumbnails, the program hangs
'                    (b) Corrected bug where when arrow keys were pressed during a slideshow the
'                        cmdThumbs (among others) was reenabled allowing it to be clicked which
'                        resulted in thumbnails to be displayed on top of the ongoing slideshow
'                    (c) Changed the font color of the thumbnail title of movies from the normal
'                        white text with a black edge, to black text with a white edge because
'                        the bmp shown instead of a thumbnail is mostly white
'                    (d) Changed the checking of descriptions to exclude because "AppleMark"
'                        has a vbLf at the end and wasn't being recognized in my exclude list
'                    (e) Changed processing so that a picture's Item number (nbrGoTo) is displayed
'                        after the picture is displayed rather than before because larger pictures
'                        take a while to display. Also added vbHourglass display.
'                    (f) Changed "Set" to "Change" in frmSS and in its menu item text and changed
'                        frmVideo's Caption and its menu item text to "Zoom Video" neither one
'                        annotated since they didn't involve code. Changed "video size multipliers"
'                        to zoom percents.
'                    (g) Corrected bug where Item number (nbrGoTo) wasn't being changed when displaying
'                        videos
'                    (h) Added ability to show a paused video at it's new size after the zoom percent
'                        is changed and the playing is resumed
'                    (i) Got rid of annoying beep heard when pressing return on nbrGoTo by replacing
'                        control with NumberBox.ocx version 1.16.1 - not annotated
'                    (j) Improved the dsiplay of the thumbnails when they are scrolled or moved by
'                        clicking the scrollbar
'                    (k) Added sort by Date Picture Taken/Date Created option
'                    (l) Moved mnuSelect to under mnuFile - not annotated
'                    (m) Added print function and made some minor tooltiptext changes
'                    (n) Added scrolling thank you's in frmAbout

'todo/problems


