Attribute VB_Name = "modCaption"
'******* 01.50f Start *******
' Added module
'******* 01.50f End *********
Option Explicit

Public Type RECT
   Left                 As Long
   Top                  As Long
   Right                As Long
   Bottom               As Long
End Type
 
Public Type LOGFONTA
   lfHeight             As Long        ' Specifies the height, in logical units, of the font's character cell or character. The character height value (also known as the em height) is the character cell height value minus the internal-leading value. (Fore more info on lfHeight, see the documentation for LOGFONT in the Win32 SDK)
   lfWidth              As Long        ' Specifies the average width, in logical units, of characters in the font. If lfWidth is zero, the aspect ratio of the device is matched against the digitization aspect ratio of the available fonts to find the closest match, determined by the absolute value of the difference.
   lfEscapement         As Long        ' Specifies the angle, in tenths of degrees, between the escapement vector and the x-axis of the device. The escapement vector is parallel to the base line of a row of text.
   lfOrientation        As Long        ' Specifies the angle, in tenths of degrees, between each character's base line and the x-axis of the device.
   lfWeight             As Long        ' Specifies the weight of the font in the range 0 through 1000. For example, 400 is normal and 700 is bold. If this value is zero, a default weight is used.
   lfItalic             As Byte        ' Specifies an italic font if set to TRUE.
   lfUnderline          As Byte        ' Specifies an underlined font if set to TRUE.
   lfStrikeOut          As Byte        ' Specifies a strikeout font if set to TRUE.
   lfCharSet            As Byte        ' Specifies the character set. (Fore more info on lfCharSet, see the documentation for LOGFONT in the Win32 SDK)
   lfOutPrecision       As Byte        ' Specifies the output precision. The output precision defines how closely the output must match the requested font's height, width, character orientation, escapement, pitch, and font type.(Fore more info on lfOutPrecision, see the documentation for LOGFONT in the Win32 SDK)
   lfClipPrecision      As Byte        ' Specifies the clipping precision. The clipping precision defines how to clip characters that are partially outside the clipping region.
   lfQuality            As Byte        ' Specifies the output quality. The output quality defines how carefully the graphics device interface (GDI) must attempt to match the logical-font attributes to those of an actual physical font.
   lfPitchAndFamily     As Byte        ' Specifies the pitch in the two low-order bits, and the family of the font in bits 4 through 7.
   lfFaceName           As String * 32
End Type
 
Public Type NONCLIENTMETRICSA
   cbSize               As Long        ' Specifies the size of the structure, in bytes.
   iBorderWidth         As Long        ' Specifies the thickness, in pixels, of the sizing border.
   iScrollWidth         As Long        ' Specifies the width, in pixels, of a standard vertical scroll bar.
   iScrollHeight        As Long        ' Specifies the height, in pixels, of a standard horizontal scroll bar.
   iCaptionWidth        As Long        ' Specifies the width, in pixels, of caption buttons.
   iCaptionHeight       As Long        ' Specifies the height, in pixels, of caption buttons.
   lfCaptionFont        As LOGFONTA    ' Contains information about the caption font.
   iSMCaptionWidth      As Long        ' Specifies the width, in pixels, of small caption buttons.
   iSMCaptionHeight     As Long        ' Specifies the height, in pixels, of small captions.
   lfSMCaptionFont      As LOGFONTA    ' Contains information about the small caption font.
   iMenuWidth           As Long        ' Specifies the width, in pixels, of menu-bar buttons.
   iMenuHeight          As Long        ' Specifies the height, in pixels, of a menu bar.
   lfMenuFont           As LOGFONTA    ' Contains information about the font used in menu bars.
   lfStatusFont         As LOGFONTA    ' Contains information about the font used in status bars and tooltips.
   lfMessageFont        As LOGFONTA    ' Contains information about the font used in message boxes.
End Type
 
' Enumeration - GetSysFont/SetSysFont
Public Enum ClientFonts
   cf_Caption = 0
   cf_SmallCaption = 1
   cf_Menu = 2
   cf_Status = 3
   cf_Message = 4
End Enum
 
' Constants - SystemParametersInfo
Public Const LOGPIXELSY = 90
Public Const SPI_GETNONCLIENTMETRICS = 41
 
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Public Declare Function PathCompactPath Lib "shlwapi.dll" Alias "PathCompactPathA" (ByVal hdc As Long, ByVal pszPath As String, ByVal dx As Long) As Long
Public Declare Function GetDeviceCaps Lib "gdi32.dll" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Public Declare Function SystemParametersInfoA Lib "user32.dll" (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long
Public Const SM_CMETRICS = 44
Public Const SM_CMOUSEBUTTONS = 43
Public Const SM_CXBORDER = 5
Public Const SM_CXCURSOR = 13
Public Const SM_CXDLGFRAME = 7
Public Const SM_CXDOUBLECLK = 36
Public Const SM_CXFIXEDFRAME = SM_CXDLGFRAME
Public Const SM_CXFRAME = 32
Public Const SM_CXFULLSCREEN = 16
Public Const SM_CXHSCROLL = 21
Public Const SM_CXHTHUMB = 10
Public Const SM_CXICON = 11
Public Const SM_CXICONSPACING = 38
Public Const SM_CXMIN = 28
Public Const SM_CXMINTRACK = 34
Public Const SM_CXSCREEN = 0
Public Const SM_CXSMSIZE = 30
Public Const SM_CXSIZEFRAME = SM_CXFRAME
Public Const SM_CXVSCROLL = 2
Public Const SM_CYBORDER = 6
Public Const SM_CYCAPTION = 4
Public Const SM_CYCURSOR = 14
Public Const SM_CYDLGFRAME = 8
Public Const SM_CYDOUBLECLK = 37
Public Const SM_CYFIXEDFRAME = SM_CYDLGFRAME
Public Const SM_CYFRAME = 33
Public Const SM_CYFULLSCREEN = 17
Public Const SM_CYHSCROLL = 3
Public Const SM_CYICON = 12
Public Const SM_CYICONSPACING = 39
Public Const SM_CYKANJIWINDOW = 18
Public Const SM_CYMENU = 15
Public Const SM_CYMIN = 29
Public Const SM_CYMINTRACK = 35
Public Const SM_CYSCREEN = 1
Public Const SM_CYSMSIZE = 31
Public Const SM_CYSIZEFRAME = SM_CYFRAME
Public Const SM_CYVSCROLL = 20
Public Const SM_CYVTHUMB = 9
Public Const SM_DBCSENABLED = 42
Public Const SM_DEBUG = 22
Public Const SM_MENUDROPALIGNMENT = 40
Public Const SM_MOUSEPRESENT = 19
Public Const SM_PENWINDOWS = 41
Public Const SM_RESERVED1 = 24
Public Const SM_RESERVED2 = 25
Public Const SM_RESERVED3 = 26
Public Const SM_RESERVED4 = 27
Public Const SM_SWAPBUTTON = 23
Public Const SM_CYSMCAPTION = 51
 
Public Const GWL_STYLE = (-16)
Public Const WS_MAXIMIZEBOX = &H10000
Public Const WS_MINIMIZEBOX = &H20000
Public Const WS_SYSMENU = &H80000
Public Function TitleBarCaptionWidth(ByVal frm As Form) As Long
    Dim DestWidth        As Long
    Dim wndRect          As RECT
    Dim rct              As RECT
    Dim XBorder          As Long
    Dim lS               As Long
    Dim lBtnWidth        As Long
    Dim DestHeight       As Long
    Dim strFnt           As New StdFont
 
    If GetSysFontA(strFnt, frm.hdc, cf_Caption) = True Then
        With frm.Font
           .Name = strFnt.Name
           .Bold = strFnt.Bold
           .Italic = strFnt.Italic
           .Size = strFnt.Size
        End With
    End If
    
   GetWindowRect frm.hWnd, wndRect
   
   With wndRect
        DestWidth = .Right - .Left
   End With
   DestHeight = GetSystemMetrics(SM_CYCAPTION)
 
   XBorder = GetSystemMetrics(SM_CXFRAME)
   'The width of the area we need to paint:
   DestWidth = DestWidth - (XBorder * 2) + 6
   lS = GetWindowLong(frm.hWnd, GWL_STYLE)

   If ((lS And WS_MINIMIZEBOX) = WS_MINIMIZEBOX) Or ((lS And WS_MAXIMIZEBOX) = WS_MAXIMIZEBOX) Then
        lBtnWidth = lBtnWidth + (GetSystemMetrics(SM_CXSMSIZE)) * 2
   End If
   If ((lS And WS_SYSMENU) = WS_SYSMENU) Then
        lBtnWidth = lBtnWidth + (GetSystemMetrics(SM_CXSMSIZE))
   End If
   If (lBtnWidth <> 0) Then lBtnWidth = lBtnWidth + 1
   DestWidth = DestWidth - lBtnWidth
 
    With rct
        .Top = XBorder
        .Left = XBorder
        .Right = XBorder + DestWidth - 4
        .Bottom = XBorder + DestHeight - 1
        
        'Move the caption text's start point over
        'to make room for the icon
        .Left = XBorder + GetSystemMetrics(SM_CXSMSIZE) + 2
        
        .Left = .Left + 2
        
        .Right = .Right - 10
        TitleBarCaptionWidth = rct.Right - rct.Left
    End With
 
End Function
 
Public Function GetSysFontA(ByRef Return_Font As StdFont, ByVal hdc As Long, ByVal FontToGet As ClientFonts) As Boolean
   Dim NCInfo           As NONCLIENTMETRICSA
   Dim FontInfo         As LOGFONTA
   
   On Error GoTo ErrorTrap
   ' Clear the return variable
   Set Return_Font = Nothing
 
   ' Set the buffer size of the parameter to be passed
   NCInfo.cbSize = Len(NCInfo)
 
   ' Get the font information
   If SystemParametersInfoA(SPI_GETNONCLIENTMETRICS, 0, NCInfo, 0) <> 0 Then
      ' Check the result
      If NCInfo.iCaptionHeight = 0 Then
         FontInfo.lfHeight = 0
      Else
         ' Store the previous caption/menu height.  If you change the font's size UP, the
         ' caption/menu height will change.  If you change the font DOWN, the caption/menu
         ' height does not automatically change smaller.
         'PrevCaptionHeight = NCInfo.iCaptionHeight
         'PrevMenuHeight = NCInfo.iMenuHeight
 
         ' Get the right font to return
         Select Case FontToGet
            Case cf_Caption
               FontInfo = NCInfo.lfCaptionFont
            Case cf_Menu
               FontInfo = NCInfo.lfMenuFont
            Case cf_Message
               FontInfo = NCInfo.lfMessageFont
            Case cf_SmallCaption
               FontInfo = NCInfo.lfSMCaptionFont
            Case cf_Status
               FontInfo = NCInfo.lfStatusFont
         End Select
         ' Set the return font according to the API results
         Set Return_Font = New StdFont
         With Return_Font
            .Charset = FontInfo.lfCharSet
            .Weight = FontInfo.lfWeight
            .Name = FontInfo.lfFaceName
            .Strikethrough = FontInfo.lfStrikeOut
            .Underline = FontInfo.lfUnderline
            .Italic = FontInfo.lfItalic
            .Bold = (FontInfo.lfWeight = 700)
            .Size = -(FontInfo.lfHeight * (72 / GetDeviceCaps(hdc, LOGPIXELSY)))
         End With
 
         GetSysFontA = True
         Exit Function
      End If
   End If
 
ErrorTrap:
 
   If Err.Number = 0 Then      ' No Error
      Resume Next
   ElseIf Err.Number = 20 Then ' Resume Without Error
      Resume Next
   Else                        ' Unknown Error
      MsgBox Err.Number & " - " & Err.Description & " in GetSysFontA"
      Err.Clear
      Exit Function
   End If
End Function
Public Function ShortenCaption(frm As Form, strCaption As String) As String

    frm.ScaleMode = vbPixels
    PathCompactPath frm.hdc, strCaption, TitleBarCaptionWidth(frm)
    ShortenCaption = strCaption
    frm.ScaleMode = vbTwips

End Function
